'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

var _base_component = require('./base_component');

var _base_component2 = _interopRequireDefault(_base_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MapComponent = function (_BaseComponent) {
  (0, _inherits3.default)(MapComponent, _BaseComponent);

  function MapComponent(props) {
    (0, _classCallCheck3.default)(this, MapComponent);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MapComponent.__proto__ || Object.getPrototypeOf(MapComponent)).call(this, props));

    (0, _utils.checkPropsPresence)(_this, 'create', 'update', 'destroy');
    return _this;
  }

  (0, _createClass3.default)(MapComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.create(this.props, this.context);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextContext) {
      this.update(nextProps, nextContext);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.destroy();
    }

    // Mandatory
    // create(props, context) {}
    // update(nextProps, nextContext) {}
    // destroy() {}

  }]);
  return MapComponent;
}(_base_component2.default);

MapComponent.contextTypes = {
  map: _propTypes2.default.object
};

exports.default = MapComponent;