React = require('react')
PropTypes = require('prop-types')

{ bindTo } = require('./utils')


class BaseComponent extends React.PureComponent
  @contextTypes: locale: PropTypes.object

  constructor: (props) ->
    super(props)
    @els = {}

  t: (args...) => @context.locale.t(args...)
  bindToComponent: (methods...) -> bindTo(@, methods...)
  setEl: (name) ->
    (el) => @els[name] = el

module.exports = BaseComponent
