InteractiveComponent = require('./interactive_component')

class InputProxyComponent extends InteractiveComponent
  getInput: -> @refs.input or @els.input
  setValue: (args...) -> @getInput().setValue(args...)
  getValue: -> @getInput().getValue()
  setError: (args...) -> @getInput().setError(args...)
  reset: (args...) -> @getInput().reset(args...)

module.exports = InputProxyComponent
