checkPropsPresence = (context, props...) ->
  for prop in props
    console.error("Please define required method/property: #{prop}") if not context[prop]

bindTo = (context, funcs...) ->
  for func in funcs
    context[func] = context[func].bind(context)

module.exports = { checkPropsPresence, bindTo }
